# Bang (Javadocs: controlP5)
Date: 2014-04-27

controlP5

## Class Bang

- java.lang.Object
- - controlP5.Controller<Bang>
  - - controlP5.Bang

All Implemented Interfaces:
  CDrawable, ControllerInterface<Bang>, ControlP5Constants

    public class Bang
    extends Controller<Bang>

The Bang controller triggers an event when pressed. A bang can only be assigned to a function in your program but not to a field like other controllers. Bang extends superclass Controller, for a full documentation see the `Controller` reference.

+Example
  `

      /**
       * ControlP5 Bang
       * A bang triggers an event that can be received by a function named after the bang.
       * By default a bang is triggered when pressed, this can be changed to 'release'
       * using theBang.setTriggerEvent(Bang.RELEASE).
       *
       * find a list of public methods available for the Bang Controller
       * at the bottom of this sketch.
       *
       * by Andreas Schlegel, 2012
       * www.sojamo.de/libraries/controlp5
       *
       */

      import controlP5.*;

      ControlP5 cp5;

      int myColorBackground = color(0, 0, 0);

      color[] col = new color[] {
        color(100), color(150), color(200), color(250)
      };

      void setup() {
        size(400, 600);
        noStroke();
        cp5 = new ControlP5(this);
        for (int i=0;i<col.length;i++) {
          cp5.addBang("bang"+i)
             .setPosition(40+i*80, 200)
             .setSize(40, 40)
             .setId(i)
             ;
        }

        // change the trigger event, by default it is PRESSED.
        cp5.addBang("bang")
           .setPosition(40, 300)
           .setSize(280, 40)
           .setTriggerEvent(Bang.RELEASE)
           .setLabel("changeBackground")
           ;

      }

      void draw() {
        background(myColorBackground);
        for (int i=0;i<col.length;i++) {
          fill(col[i]);
          rect(40+i*80, 50, 40, 80);
        }
      }

      public void bang() {
        int theColor = (int)random(255);
        myColorBackground = color(theColor);
        println("### bang(). a bang event. setting background to "+theColor);
      }

      public void controlEvent(ControlEvent theEvent) {
        for (int i=0;i<col.length;i++) {
          if (theEvent.getController().getName().equals("bang"+i)) {
            col[i] = color(random(255));
          }
        }

        println(
        "## controlEvent / id:"+theEvent.controller().id()+
          " / name:"+theEvent.controller().name()+
          " / label:"+theEvent.controller().label()+
          " / value:"+theEvent.controller().value()
          );
      }

      /*
      a list of all methods available for the Bang Controller
      use ControlP5.printPublicMethodsFor(Bang.class);
      to print the following list into the console.

      You can find further details about class Bang in the javadoc.

      Format:
      ClassName : returnType methodName(parameter type)

      controlP5.Bang : Bang setTriggerEvent(int)
      controlP5.Bang : Bang setValue(float)
      controlP5.Bang : Bang update()
      controlP5.Bang : String getInfo()
      controlP5.Bang : String toString()
      controlP5.Bang : int getTriggerEvent()
      controlP5.Controller : Bang addCallback(CallbackListener)
      controlP5.Controller : Bang addListener(ControlListener)
      controlP5.Controller : Bang bringToFront()
      controlP5.Controller : Bang bringToFront(ControllerInterface)
      controlP5.Controller : Bang hide()
      controlP5.Controller : Bang linebreak()
      controlP5.Controller : Bang listen(boolean)
      controlP5.Controller : Bang lock()
      controlP5.Controller : Bang plugTo(Object)
      controlP5.Controller : Bang plugTo(Object, String)
      controlP5.Controller : Bang plugTo(Object[])
      controlP5.Controller : Bang plugTo(Object[], String)
      controlP5.Controller : Bang registerProperty(String)
      controlP5.Controller : Bang registerProperty(String, String)
      controlP5.Controller : Bang registerTooltip(String)
      controlP5.Controller : Bang removeBehavior()
      controlP5.Controller : Bang removeCallback()
      controlP5.Controller : Bang removeCallback(CallbackListener)
      controlP5.Controller : Bang removeListener(ControlListener)
      controlP5.Controller : Bang removeProperty(String)
      controlP5.Controller : Bang removeProperty(String, String)
      controlP5.Controller : Bang setArrayValue(float[])
      controlP5.Controller : Bang setArrayValue(int, float)
      controlP5.Controller : Bang setBehavior(ControlBehavior)
      controlP5.Controller : Bang setBroadcast(boolean)
      controlP5.Controller : Bang setCaptionLabel(String)
      controlP5.Controller : Bang setColor(CColor)
      controlP5.Controller : Bang setColorActive(int)
      controlP5.Controller : Bang setColorBackground(int)
      controlP5.Controller : Bang setColorCaptionLabel(int)
      controlP5.Controller : Bang setColorForeground(int)
      controlP5.Controller : Bang setColorValueLabel(int)
      controlP5.Controller : Bang setDecimalPrecision(int)
      controlP5.Controller : Bang setDefaultValue(float)
      controlP5.Controller : Bang setHeight(int)
      controlP5.Controller : Bang setId(int)
      controlP5.Controller : Bang setImages(PImage, PImage, PImage)
      controlP5.Controller : Bang setImages(PImage, PImage, PImage, PImage)
      controlP5.Controller : Bang setLabelVisible(boolean)
      controlP5.Controller : Bang setLock(boolean)
      controlP5.Controller : Bang setMax(float)
      controlP5.Controller : Bang setMin(float)
      controlP5.Controller : Bang setMouseOver(boolean)
      controlP5.Controller : Bang setMoveable(boolean)
      controlP5.Controller : Bang setPosition(PVector)
      controlP5.Controller : Bang setPosition(float, float)
      controlP5.Controller : Bang setSize(PImage)
      controlP5.Controller : Bang setSize(int, int)
      controlP5.Controller : Bang setStringValue(String)
      controlP5.Controller : Bang setUpdate(boolean)
      controlP5.Controller : Bang setValueLabel(String)
      controlP5.Controller : Bang setView(ControllerView)
      controlP5.Controller : Bang setVisible(boolean)
      controlP5.Controller : Bang setWidth(int)
      controlP5.Controller : Bang show()
      controlP5.Controller : Bang unlock()
      controlP5.Controller : Bang unplugFrom(Object)
      controlP5.Controller : Bang unplugFrom(Object[])
      controlP5.Controller : Bang unregisterTooltip()
      controlP5.Controller : Bang update()
      controlP5.Controller : Bang updateSize()
      controlP5.Controller : CColor getColor()
      controlP5.Controller : ControlBehavior getBehavior()
      controlP5.Controller : ControlWindow getControlWindow()
      controlP5.Controller : ControlWindow getWindow()
      controlP5.Controller : ControllerProperty getProperty(String)
      controlP5.Controller : ControllerProperty getProperty(String, String)
      controlP5.Controller : Label getCaptionLabel()
      controlP5.Controller : Label getValueLabel()
      controlP5.Controller : List getControllerPlugList()
      controlP5.Controller : PImage setImage(PImage)
      controlP5.Controller : PImage setImage(PImage, int)
      controlP5.Controller : PVector getAbsolutePosition()
      controlP5.Controller : PVector getPosition()
      controlP5.Controller : String getAddress()
      controlP5.Controller : String getInfo()
      controlP5.Controller : String getName()
      controlP5.Controller : String getStringValue()
      controlP5.Controller : String toString()
      controlP5.Controller : Tab getTab()
      controlP5.Controller : boolean isActive()
      controlP5.Controller : boolean isBroadcast()
      controlP5.Controller : boolean isInside()
      controlP5.Controller : boolean isLabelVisible()
      controlP5.Controller : boolean isListening()
      controlP5.Controller : boolean isLock()
      controlP5.Controller : boolean isMouseOver()
      controlP5.Controller : boolean isMousePressed()
      controlP5.Controller : boolean isMoveable()
      controlP5.Controller : boolean isUpdate()
      controlP5.Controller : boolean isVisible()
      controlP5.Controller : float getArrayValue(int)
      controlP5.Controller : float getDefaultValue()
      controlP5.Controller : float getMax()
      controlP5.Controller : float getMin()
      controlP5.Controller : float getValue()
      controlP5.Controller : float[] getArrayValue()
      controlP5.Controller : int getDecimalPrecision()
      controlP5.Controller : int getHeight()
      controlP5.Controller : int getId()
      controlP5.Controller : int getWidth()
      controlP5.Controller : int listenerSize()
      controlP5.Controller : void remove()
      controlP5.Controller : void setView(ControllerView, int)
      java.lang.Object : String toString()
      java.lang.Object : boolean equals(Object)

      */

      </pre>

  `

### Field Summary

### Fields inherited from class controlP5.Controller

`autoHeight, autoSpacing, autoWidth`

### Fields inherited from interface controlP5.ControlP5Constants

`acceptClassList, ACTION_BROADCAST, ACTION_CLICK, ACTION_DRAG, ACTION_ENTER, ACTION_EXIT, ACTION_LEAVE, ACTION_MOVE, ACTION_PRESS, ACTION_PRESSED, ACTION_RELEASE, ACTION_RELEASED, ACTION_RELEASEDOUTSIDE, ACTION_WHEEL, ACTIVE, ALL, ALT, AQUA, ARC, ARRAY, BACKSPACE, BASELINE, BITFONT, BLACK, BLUE, BOOLEAN, BOTTOM, BOTTOM_OUTSIDE, CAPTIONLABEL, CENTER, CHECKBOX, COMMANDKEY, CONTROL, controlEventClass, CUSTOM, DECREASE, DEFAULT, DELETE, DONE, DOWN, DROPDOWN, ELLIPSE, ENTER, ESCAPE, EVENT, eventMethod, FADEIN, FADEOUT, FIELD, FLOAT, FUCHSIA, GRAY, GREEN, grixel, HALF_PI, HIDE, HIGHLIGHT, HORIZONTAL, IDLE, IMAGE, INACTIVE, INCREASE, INTEGER, INVALID, J2D, KEYCONTROL, LEFT, LEFT_OUTSIDE, LIME, LINE, LIST, LOAD, MAROON, MENU, METHOD, MOVE, MULTI, MULTIPLES, NAVY, OLIVE, ORANGE, OVER, P2D, P3D, PI, PRESSED, PRINT, PURPLE, RED, RELEASE, RESET, RIGHT, RIGHT_OUTSIDE, SAVE, SHIFT, SILVER, SINGLE, SINGLE_COLUMN, SINGLE_ROW, SPRITE, standard56, standard58, STRING, SWITCH, SWITCH_BACK, SWITCH_FORE, synt24, TAB, TEAL, THEME_A, THEME_CP52014, THEME_CP5BLUE, THEME_RED, THEME_RETRO, THEME_WHITE, TOP, TOP_OUTSIDE, TRANSITION_WAIT_FADEIN, TREE, TWO_PI, UP, VALUELABEL, VERBOSE, VERTICAL, WAIT, WHITE, YELLOW`

### Constructor Summary

Constructors
Constructor and Description
`Bang(ControlP5 theControlP5, java.lang.String theName)` Convenience constructor to extend Bang.

### Method Summary

Methods
`java.lang.String` `getInfo()`
`int` `getTriggerEvent()`
`Bang` `setTriggerEvent(int theEventID)` By default a bang is triggered when the mouse is pressed.
`Bang` `setValue(float theValue)` Sets the value of the bang controller.
`java.lang.String` `toString()`
`Bang` `update()` updates the value of the controller without having to set the value explicitly.
`Bang` `updateDisplayMode(int theMode)`
`Bang` `updateViewMode(int theMode)`

### Methods inherited from class controlP5.Controller

`add, addCallback, addListener, align, bringToFront, bringToFront, changeValue, continuousUpdateEvents, draw, getAbsolutePosition, getAddress, getArrayValue, getArrayValue, getBehavior, getCaptionLabel, getColor, getControllerPlugList, getControlWindow, getDecimalPrecision, getDefaultValue, getHeight, getId, getLabel, getMax, getMin, getName, getParent, getPickingColor, getPointer, getPosition, getProperty, getProperty, getStringValue, getTab, getValue, getValueLabel, getView, getWidth, getWindow, hide, init, isActive, isBroadcast, isInside, isLabelVisible, isListening, isLock, isMouseOver, isMousePressed, isMoveable, isUpdate, isUserInteraction, isVisible, keyEvent, linebreak, listen, listenerSize, lock, moveTo, moveTo, moveTo, moveTo, moveTo, moveTo, moveTo, moveTo, moveTo, plugTo, plugTo, plugTo, plugTo, registerProperty, registerProperty, registerTooltip, remove, remove, removeBehavior, removeCallback, removeCallback, removeListener, removeProperty, removeProperty, setAbsolutePosition, setAddress, setArrayValue, setArrayValue, setBehavior, setBroadcast, setCaptionLabel, setColor, setColorActive, setColorBackground, setColorCaptionLabel, setColorForeground, setColorValueLabel, setDecimalPrecision, setDefaultValue, setGroup, setGroup, setHeight, setId, setImage, setImage, setImages, setImages, setImages, setLabelVisible, setLock, setMax, setMin, setMouseOver, setMousePressed, setMoveable, setParent, setPosition, setPosition, setSize, setSize, setStringValue, setTab, setTab, setUpdate, setUserInteraction, setValueLabel, setValueSelf, setView, setView, setVisible, setWidth, show, unlock, unplugFrom, unplugFrom, unregisterTooltip, updateAbsolutePosition, updateEvents, updateInternalEvents, updateSize`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface controlP5.ControllerInterface

`parent, setColorLabel, setColorValue, setLabel`

### Constructor Detail

#### Bang

    public Bang(ControlP5 theControlP5,
        java.lang.String theName)

Convenience constructor to extend Bang.

Parameters:
  `theControlP5` -
  `theName` -

+Example
  `

      /**
       * ControlP5 extending Controllers
       *
       * the following example shows how to extend the Controller class to
       * create customizable Controllers. You can either extend the Controller class itself,
       * or any class that extends Controller itself like the Slider, Button, DropdownList, etc.
       *
       * How to:
       *
       * 1) do a super call to the convenience constructor requiring
       * 2 parameter (ControlP5 instance, name)
       *
       * 2) the Controller class has a set of empty methods that allow you to capture
       * inputs from the mouse including
       * onEnter(), onLeave(), onPress(), onRelease(), onClick(), onScroll(int), onDrag()
       * These you can override and include functionality as needed.
       *
       * 3) use method getPointer() to return the local (relative)
       * xy-coordinates of the controller
       *
       * 4) after instantiation custom controllers are treated the same
       * as default controlP5 controllers.
       *
       * by Andreas Schlegel, 2012
       * www.sojamo.de/libraries/controlp5
       *
       */

      import controlP5.*;

      ControlP5 cp5;
      PApplet p;

      void setup() {
        size(400, 400);
        cp5 = new ControlP5(this);

        // create 2 groups to show nesting of custom controllers and
        //
        Group g1 = cp5.addGroup("a").setPosition(0,100).setWidth(180);
        Group g2 = cp5.addGroup("b").setPosition(0,10).setWidth(180);
        g2.moveTo(g1);

        // create 2 custom Controllers from class MyButton
        // MyButton extends Controller and inherits all methods accordingly.
        new MyButton(cp5, "b1").setPosition(0, 0).setSize(180, 200).moveTo(g2);
        new MyButton(cp5, "b2").setPosition(205, 15).setSize(180, 200);

      }

      void draw() {
        background(0);
      }

      // b1 will be called from Controller b1
      public void b1(float theValue) {
        println("yay button "+theValue);
      }

      public void controlEvent(ControlEvent theEvent) {
        println("controlEvent : "+theEvent);
      }

      // Create a custom Controller, please not that
      // MyButton extends Controller<MyButton>, <MyButton>
      // is an indicator for the super class about the type of
      // custom controller to be created.

      class MyButton extends Controller<MyButton> {

        int current = 0xffff0000;

        float a = 128;

        float na;

        int y;

        // use the convenience constructor of super class Controller
        // MyButton will automatically registered and move to the
        // default controlP5 tab.

        MyButton(ControlP5 cp5, String theName) {
          super(cp5, theName);

          // replace the default view with a custom view.
          setView(new ControllerView() {
            public void display(PApplet p, Object b) {
              // draw button background
              na += (a-na) * 0.1;
              p.fill(current,na);
              p.rect(0, 0, getWidth(), getHeight());

              // draw horizontal line which can be moved on the x-axis
              // using the scroll wheel.
              p.fill(0,255,0);
              p.rect(0,y,width,10);

              // draw the custom label
              p.fill(128);
              translate(0,getHeight()+14);
              p.text(getName(),0,0);
              p.text(getName(),0,0);

            }
          }
          );
        }

        // override various input methods for mouse input control
        void onEnter() {
          cursor(HAND);
          println("enter");
          a = 255;
        }

        void onScroll(int n) {
          println("scrolling");
          y -= n;
          y = constrain(y,0,getHeight()-10);
        }

        void onPress() {
          println("press");
          current = 0xffffff00;
        }

        void onClick() {
          Pointer p1 = getPointer();
          println("clicked at "+p1.x()+", "+p1.y());
          current = 0xffffff00;
          setValue(y);
        }

        void onRelease() {
          println("release");
          current = 0xffffffff;
        }

        void onMove() {
          println("moving "+this+" "+_myControlWindow.getMouseOverList());
        }

        void onDrag() {
          current = 0xff0000ff;
          Pointer p1 = getPointer();
          float dif = dist(p1.px(),p1.py(),p1.x(),p1.y());
          println("dragging at "+p1.x()+", "+p1.y()+" "+dif);
        }

        void onReleaseOutside() {
          onLeave();
        }

        void onLeave() {
          println("leave");
          cursor(ARROW);
          a = 128;
        }
      }

  `

### Method Detail

#### getInfo

    public java.lang.String getInfo()

Overrides:
  `getInfo` in class `Controller<Bang>`
Returns:
  String

#### getTriggerEvent

    public int getTriggerEvent()

#### setTriggerEvent

    public Bang setTriggerEvent(int theEventID)

By default a bang is triggered when the mouse is pressed. use setTriggerEvent(Bang.PRESSED) or setTriggerEvent(Bang.RELEASE) to define the action for triggering a bang. currently only Bang.PRESSED and Bang.RELEASE are supported.

Parameters:
  `theEventID` -
Returns:
  Bang

#### setValue

    public Bang setValue(float theValue)

Sets the value of the bang controller. since bang can be true or false, false=0 and true=1

Specified by:
  `setValue` in interface `ControllerInterface<Bang>`
Overrides:
  `setValue` in class `Controller<Bang>`
Parameters:
  `theValue` - float
Returns:
  Bang

#### toString

    public java.lang.String toString()

Overrides:
  `toString` in class `Controller<Bang>`

#### update

    public Bang update()

Description copied from class: `Controller`
updates the value of the controller without having to set the value explicitly. update does not visually update the controller. the updating status can be set with setUpdate(true/false) and checked with isUpdate().

Specified by:
  `update` in interface `ControllerInterface<Bang>`
Overrides:
  `update` in class `Controller<Bang>`
Returns:
  Controller
See Also:
  `Controller.setUpdate(boolean)`, `Controller.isUpdate()`

#### updateDisplayMode

    public Bang updateDisplayMode(int theMode)

#### updateViewMode

    public Bang updateViewMode(int theMode)